<html>
<head>
<title>OgreTerrainLayerBlendMap.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_6cd0971983c3e0e5b0cb362e5db7fc9d.html">Terrain</a>      </li>
      <li class="navelem"><a class="el" href="dir_9b506231b651991d884bb23d993d7984.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTerrainLayerBlendMap.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTerrainLayerBlendMap_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_TerrainLayerBlendMap_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_TerrainLayerBlendMap_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTerrainPrerequisites_8h.html">OgreTerrainPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039     <span class="keyword">class </span>Image;
<a name="l00061"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html">00061</a>     <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html" title="Class exposing an interface to a blend map for a given layer.">TerrainLayerBlendMap</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063     <span class="keyword">protected</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a42e5b0108901f14435d4466e893d024d">00064</a>         <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a42e5b0108901f14435d4466e893d024d">mParent</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a14c104352a8d2b06d891f99679e3e9dc">00065</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a14c104352a8d2b06d891f99679e3e9dc">mLayerIdx</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a0f6b814b852b0d4646ee1de61ab3541f">00066</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a0f6b814b852b0d4646ee1de61ab3541f">mChannel</a>; <span class="comment">// RGBA</span>
<a name="l00067"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#aef9d829eacad0e5a7c9aa04d728ef27a">00067</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#aef9d829eacad0e5a7c9aa04d728ef27a">mChannelOffset</a>; <span class="comment">// in pixel format</span>
<a name="l00068"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a3e38361219504daeaf53c09b93c07598">00068</a>         <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Box</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a3e38361219504daeaf53c09b93c07598">mDirtyBox</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a44410031b859e531c33bfdcb3a166452">00069</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a44410031b859e531c33bfdcb3a166452">mDirty</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a40dcdac7212ac7d58bd460f4b4bf5c06">00070</a>         <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>* <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a40dcdac7212ac7d58bd460f4b4bf5c06">mBuffer</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a859440a85cbd4a328efbfc218462d6bb">00071</a>         <span class="keywordtype">float</span>* <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a859440a85cbd4a328efbfc218462d6bb">mData</a>;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="keywordtype">void</span> download();
<a name="l00074"></a>00074         <span class="keywordtype">void</span> upload();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keyword">public</span>:
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html" title="Class exposing an interface to a blend map for a given layer.">TerrainLayerBlendMap</a>(<a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* parent, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> layerIndex, <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>* buf);
<a name="l00084"></a>00084         ~<a class="code" href="classOgre_1_1TerrainLayerBlendMap.html" title="Class exposing an interface to a blend map for a given layer.">TerrainLayerBlendMap</a>();
<a name="l00086"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#aac3a0664709cab419c63d86e7cdd3566">00086</a>         <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#aac3a0664709cab419c63d86e7cdd3566" title="Get the parent terrain.">getParent</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00088"></a><a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a90f88bdb0784c24154ab6d55e18df722">00088</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1TerrainLayerBlendMap.html#a90f88bdb0784c24154ab6d55e18df722" title="Get the index of the layer this is targeting.">getLayerIndex</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLayerIdx; }
<a name="l00089"></a>00089 
<a name="l00098"></a>00098         <span class="keywordtype">void</span> convertWorldToUVSpace(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldPos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> *outX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* outY);
<a name="l00099"></a>00099 
<a name="l00105"></a>00105         <span class="keywordtype">void</span> convertUVToWorldSpace(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* outWorldPos);
<a name="l00106"></a>00106 
<a name="l00109"></a>00109         <span class="keywordtype">void</span> convertUVToImageSpace(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <span class="keywordtype">size_t</span>* outX, <span class="keywordtype">size_t</span>* outY);
<a name="l00112"></a>00112         <span class="keywordtype">void</span> convertImageToUVSpace(<span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* outX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* outY);
<a name="l00115"></a>00115         <span class="keywordtype">void</span> convertImageToTerrainSpace(<span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* outX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* outY);
<a name="l00118"></a>00118         <span class="keywordtype">void</span> convertTerrainToImageSpace(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <span class="keywordtype">size_t</span>* outX, <span class="keywordtype">size_t</span>* outY);
<a name="l00119"></a>00119 
<a name="l00124"></a>00124         <span class="keywordtype">float</span> getBlendValue(<span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y);
<a name="l00125"></a>00125 
<a name="l00130"></a>00130         <span class="keywordtype">void</span> setBlendValue(<span class="keywordtype">size_t</span> x, <span class="keywordtype">size_t</span> y, <span class="keywordtype">float</span> val);
<a name="l00131"></a>00131 
<a name="l00138"></a>00138         <span class="keywordtype">float</span>* getBlendPointer();
<a name="l00139"></a>00139 
<a name="l00142"></a>00142         <span class="keywordtype">void</span> dirty();
<a name="l00143"></a>00143 
<a name="l00147"></a>00147         <span class="keywordtype">void</span> dirtyRect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00148"></a>00148 
<a name="l00157"></a>00157         <span class="keywordtype">void</span> blit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Box</a> &amp;dstBox);
<a name="l00158"></a>00158         
<a name="l00165"></a>00165         <span class="keywordtype">void</span> blit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src);
<a name="l00166"></a>00166 
<a name="l00169"></a>00169         <span class="keywordtype">void</span> loadImage(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; img);
<a name="l00170"></a>00170 
<a name="l00175"></a>00175         <span class="keywordtype">void</span> loadImage(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; ext = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00176"></a>00176 
<a name="l00179"></a>00179         <span class="keywordtype">void</span> loadImage(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185         <span class="keywordtype">void</span> update();
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     };
<a name="l00189"></a>00189 
<a name="l00190"></a><a class="code" href="group__Terrain.html#ga0abaf85368e5e249f471ee358e7c8f60">00190</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TerrainLayerBlendMap*&gt;::type</a> <a class="code" href="group__Terrain.html#ga0abaf85368e5e249f471ee358e7c8f60">TerrainLayerBlendMapList</a>;
<a name="l00191"></a>00191 
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
